Index: TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/InstallGroovyCoNLLUFiles.java
===================================================================
--- TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/InstallGroovyCoNLLUFiles.java	(revision 0)
+++ TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/InstallGroovyCoNLLUFiles.java	(revision 3300)
@@ -0,0 +1,53 @@
+package org.txm.conllu.core;
+
+import java.io.File;
+
+import org.txm.PostTXMHOMEInstallationStep;
+import org.txm.Toolbox;
+import org.txm.objects.Workspace;
+import org.txm.utils.BundleUtils;
+
+public class InstallGroovyCoNLLUFiles extends PostTXMHOMEInstallationStep {
+
+	final static String createfolders[] = {"scripts/groovy/lib", "scripts/groovy/user", "scripts/groovy/system"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
+	
+	@Override
+	public boolean do_install(Workspace workspace) {
+		File txmhomedir = new File(Toolbox.getTxmHomePath());
+		
+		for (String folder : createfolders) {
+			new File(txmhomedir, folder).mkdirs();
+		}
+		File scriptsDirectory = new File(txmhomedir, "scripts/groovy");
+		File userDirectory = new File(scriptsDirectory, "user");
+		File systemDirectory = new File(scriptsDirectory, "system");
+		
+		String bundle_id = "org.txm.conllu.core";
+		File scriptsPackageDirectory = new File(userDirectory, "org/txm/scripts/importer");
+		File scriptsPackageDirectory2 = new File(systemDirectory, "org/txm/scripts/importer");
+		scriptsPackageDirectory.mkdirs();
+		scriptsPackageDirectory2.mkdirs();
+		BundleUtils.copyFiles(bundle_id, "groovy", "org/txm/scripts/importer", "", scriptsPackageDirectory, true);
+		BundleUtils.copyFiles(bundle_id, "groovy", "org/txm/scripts/importer", "", scriptsPackageDirectory2, true);
+	
+		return scriptsDirectory.exists();
+	}
+
+	@Override
+	public String getName() {
+		return "UD (org.txm.conllu.core)";
+	}
+	
+	@Override
+	public boolean needsReinstall(Workspace workspace) {
+		File txmhomedir = new File(Toolbox.getTxmHomePath());
+		for (String folder : createfolders) {
+			if (!new File(txmhomedir, folder).exists()) {
+				return true;
+			}
+		}
+		
+		
+		return false;
+	}
+}

Index: TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/preferences/UDPreferences.java
===================================================================
--- TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/preferences/UDPreferences.java	(revision 0)
+++ TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/preferences/UDPreferences.java	(revision 3300)
@@ -0,0 +1,52 @@
+package org.txm.conllu.core.preferences;
+
+
+import org.osgi.service.prefs.Preferences;
+import org.txm.core.preferences.TXMPreferences;
+
+/**
+ * Preferences initializer and manager.
+ * 
+ * @author mdecorde
+ *
+ */
+public class UDPreferences extends TXMPreferences {
+	
+	
+	public static String VERSION = "version";
+	
+	public static String UDPREFIX = "ud_prefix";
+	
+	public static String KEEP_CONTRACTIONS = "import_keep_contractions";
+	
+	public static String IMPORT_USE_NEW_DOC_ID = "import_use_new_doc_id";
+	
+	public static String IMPORT_HEAD_TO_PROJECT = "import_head_to_project";
+	
+	public static String IMPORT_DEPS_TO_PROJECT = "import_deps_to_project";
+	
+	/**
+	 * Gets the instance.
+	 * 
+	 * @return the instance
+	 */
+	public static TXMPreferences getInstance() {
+		if (!TXMPreferences.instances.containsKey(UDPreferences.class)) {
+			new UDPreferences();
+		}
+		return TXMPreferences.instances.get(UDPreferences.class);
+	}
+	
+	
+	@Override
+	public void initializeDefaultPreferences() {
+		super.initializeDefaultPreferences();
+		
+		Preferences preferences = this.getDefaultPreferencesNode();
+		preferences.put(UDPREFIX, "ud-");
+		preferences.put(IMPORT_HEAD_TO_PROJECT, "upos,deprel");
+		preferences.put(IMPORT_DEPS_TO_PROJECT, "upos,deprel");
+		preferences.putBoolean(KEEP_CONTRACTIONS, true);
+		preferences.putBoolean(IMPORT_USE_NEW_DOC_ID, true);
+	}
+}

Index: TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/ImportCoNLLUAnnotations.java
===================================================================
--- TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/ImportCoNLLUAnnotations.java	(revision 0)
+++ TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/ImportCoNLLUAnnotations.java	(revision 3300)
@@ -0,0 +1,275 @@
+package org.txm.conllu.core.function;
+
+import java.io.BufferedReader;
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.LinkedHashMap;
+import java.util.Set;
+
+import javax.xml.stream.XMLStreamException;
+
+import org.apache.commons.lang.StringUtils;
+import org.txm.objects.Text;
+import org.txm.searchengine.cqp.corpus.MainCorpus;
+import org.txm.utils.AsciiUtils;
+import org.txm.utils.io.FileCopy;
+import org.txm.utils.io.IOUtils;
+import org.txm.utils.logger.Log;
+import org.txm.xml.xmltxm.XMLTXMWordPropertiesInjection;
+
+public class ImportCoNLLUAnnotations {
+	
+	public static final String[] UD_PROPERTY_NAMES = { "id", "form", "lemma", "upos", "xpos", "feats", "head", "deprel", "deps", "misc" };
+	
+	public static int _importAnnotations(File coonluFile, MainCorpus mainCorpus, String propertiesPrefix, String textId, Boolean normalize_word_ids, Set<String> headPropertiesToProject, Set<String> depsPropertiesToProject, Set<String> udPropertiesToImport) throws IOException, XMLStreamException {
+		
+		if (textId == null || textId.length() == 0) { // no text id provided, using the conllu file name
+			textId = coonluFile.getName().substring(0, coonluFile.getName().length() - 7);
+		}
+		
+		Log.info("** processing text: " + textId);
+		Text text = mainCorpus.getProject().getText(textId);
+		if (text == null) {
+			Log.warning("No text found with ID=" + textId);
+			return 0;
+		}
+		File xmltxmFile = mainCorpus.getProject().getText(textId).getXMLTXMFile();
+		File xmltxmUpdatedFile = new File(System.getProperty("java.io.tmpdir"), xmltxmFile.getName());
+		
+		XMLTXMWordPropertiesInjection processor = new XMLTXMWordPropertiesInjection(xmltxmFile);
+		HashMap<String, HashMap<String, String>> rules = new HashMap<>();
+		processor.setProperties(rules);
+		
+		BufferedReader reader = IOUtils.getReader(coonluFile);
+		String line = reader.readLine();
+		
+		int nWords2 = 0;
+		int nLine = 0;
+		String sent_id = null;
+		String newpar_id = null;
+		String newdoc_id = null;
+		LinkedHashMap<String, HashMap<String, String>> sentenceProperties = new LinkedHashMap<String, HashMap<String, String>>();
+		while (line != null) {
+			nLine++;
+			if (line.length() == 0) {
+				line = reader.readLine();
+				continue; // comment
+			}
+			
+			if (line.startsWith("#")) {
+				if (line.startsWith("# sent_id = ")) {
+					
+					// write previous sentence word properties
+					if (sentenceProperties.size() > 0) {
+						storeSentenceProperties(sentenceProperties, processor, propertiesPrefix, headPropertiesToProject, depsPropertiesToProject);
+					}
+					
+					sent_id = line.substring(12).trim();
+					
+				}
+				else if (line.startsWith("# newdoc id = ")) {
+					newdoc_id = line.substring(14).trim();
+				}
+				else if (line.startsWith("# newpar id = ")) {
+					newpar_id = line.substring(14).trim();
+				}
+				else {
+					// nothing for now
+				}
+				
+				line = reader.readLine();
+				continue; // comment
+			}
+			
+			String[] split = line.split("\t", 10);
+			if (split.length < 10) {
+				Log.warning("Error: line " + nLine + " : " + line + " -> " + Arrays.toString(split) + " len=" + split.length);
+				line = reader.readLine();
+				continue; // comment
+			}
+			
+			String misc = split[9];
+			String[] miscValues = misc.split("\\|");
+			String wId = null;
+			for (String miscValue : miscValues) {
+				if (miscValue.startsWith("XmlId=")) {
+					wId = miscValue.substring(6);
+				}
+			}
+			
+			HashMap<String, String> properties = new HashMap<>();
+			for (int i = 0; i < split.length; i++) {
+				properties.put(UD_PROPERTY_NAMES[i], split[i]); // add the property name using the prefix ; XML-TXM types are prefixed with '#'
+			}
+			
+			if (sent_id != null) {
+				properties.put("#"+propertiesPrefix+"sentid", sent_id);
+				sent_id = ""; // reset value for next sentence
+			}
+			else {
+				properties.put("#"+propertiesPrefix+"sentid", "");
+			}
+			
+			if (newdoc_id != null) {
+				properties.put("#"+propertiesPrefix+"newdocid", newdoc_id);
+				newdoc_id = null; // reset value for next sentence
+			}
+			else {
+				properties.put("#"+propertiesPrefix+"newdocid", "");
+			}
+			
+			if (newpar_id != null) {
+				properties.put("#"+propertiesPrefix+"newparid", newpar_id);
+				newpar_id = null; // reset value for next sentence
+			}
+			else {
+				properties.put("#"+propertiesPrefix+"newparid", "");
+			}
+			
+			if (wId == null) {
+				Log.warning("No 'XmlId=' found for UD line: " + line);
+			}
+			else {
+				
+				if (normalize_word_ids) {
+					if (!wId.startsWith("w_")) {
+						wId = "w_" + wId.substring(1);
+					}
+					wId = AsciiUtils.buildWordId(wId);
+				}
+				
+				sentenceProperties.put(wId, properties);
+				nWords2++;
+			}
+			line = reader.readLine();
+		}
+		reader.close();
+		
+		// IF ANY write previous sentence word properties 
+		if (sentenceProperties.size() > 0) {
+			storeSentenceProperties(sentenceProperties, processor, propertiesPrefix, headPropertiesToProject, depsPropertiesToProject);
+		}
+		
+		if (nWords2 == 0) {
+			Log.warning("** No annotation to import in " + coonluFile);
+			return 0;
+		}
+		
+		Log.info("** Loading annotations from : " + coonluFile+" "+processor.getRules().size()+" injections to do.");
+		if (processor.process(xmltxmUpdatedFile)) {
+			if (xmltxmFile.delete() && FileCopy.copy(xmltxmUpdatedFile, xmltxmFile)) {
+				if (processor.getNonActivatedRules().size() > 0) {
+					Log.warning("Warning: some words were not imported: " + StringUtils.join(processor.getNonActivatedRules(), ", "));
+				}
+			}
+			else {
+				Log.warning("** Warning: annotation import failed for replace the corpus XML-TXM file: " + xmltxmFile + ". TEMP file: " + xmltxmUpdatedFile);
+				return 0;
+			}
+		}
+		else {
+			Log.warning("** Warning: annotation import failed for text: " + textId);
+			return 0;
+		}
+		
+		if (processor.getNInsertions() == 0) {
+			Log.warning("** No annotation imported in " + textId);
+		}
+		
+		return processor.getNInsertions();
+	}
+
+	public static void buildPropertiesProjections(LinkedHashMap<String, HashMap<String, String>> sentenceProperties, Set<String> headPropertiesToProject, Set<String> depsPropertiesToProject) throws IOException, XMLStreamException {
+		
+		//System.out.println("Building "+headPropertiesToProject+" and "+depsPropertiesToProject+" in "+sentenceProperties);
+		if (headPropertiesToProject.size() > 0) {
+			
+			for (String wId : sentenceProperties.keySet()) {
+				
+				HashMap<String, String> properties = sentenceProperties.get(wId); 
+				
+				for (String wheadid : sentenceProperties.keySet()) { // find the word head properties
+					
+					HashMap<String, String> headProperties = sentenceProperties.get(wheadid); 
+
+					if (headProperties.get("id").equals(properties.get("head"))) { // a word which head is the current word id
+						// { "form", "lemma", "upos", "xpos", "feats", "deprel", "deps", "misc" };
+						if (headPropertiesToProject.contains("form")) properties.put("head-form", headProperties.get("form"));
+						if (headPropertiesToProject.contains("lemma")) properties.put("head-lemma", headProperties.get("lemma"));
+						if (headPropertiesToProject.contains("upos")) properties.put("head-upos", headProperties.get("upos"));
+						if (headPropertiesToProject.contains("xpos")) properties.put("head-xpos", headProperties.get("xpos"));
+						if (headPropertiesToProject.contains("feats")) properties.put("head-feats", headProperties.get("feats"));
+						if (headPropertiesToProject.contains("deprel")) properties.put("head-deprel", headProperties.get("deprel"));
+						if (headPropertiesToProject.contains("deps")) properties.put("head-deps", headProperties.get("deps"));
+						if (headPropertiesToProject.contains("misc")) properties.put("head-misc", headProperties.get("misc"));
+						break; // the is only one head per word
+					}
+				}
+			}
+		}
+		
+		if (depsPropertiesToProject.size() > 0) {
+			
+			for (String wId : sentenceProperties.keySet()) {
+				
+				HashMap<String, String> properties = sentenceProperties.get(wId); 
+				HashMap<String, String> newProperties = new HashMap<String, String>();
+				if (depsPropertiesToProject.contains("id")) newProperties.put("dep-id", "|");
+				if (depsPropertiesToProject.contains("form")) newProperties.put("dep-form", "|");
+				if (depsPropertiesToProject.contains("lemma")) newProperties.put("dep-lemma", "|");
+				if (depsPropertiesToProject.contains("upos")) newProperties.put("dep-upos", "|");
+				if (depsPropertiesToProject.contains("xpos")) newProperties.put("dep-xpos", "|");
+				if (depsPropertiesToProject.contains("deprel")) newProperties.put("dep-deprel", "|");
+				if (depsPropertiesToProject.contains("deps")) newProperties.put("dep-deps", "|");
+				if (depsPropertiesToProject.contains("misc")) newProperties.put("dep-misc", "|");
+				
+				// browse each dep properties to build the depXYZ properties
+				for (String wdepid : sentenceProperties.keySet()) {
+					
+					HashMap<String, String> depProperties = sentenceProperties.get(wdepid); 
+					if (depProperties.get("head").equals(properties.get("id"))) { // a word which head is the current word id
+						
+						if (depsPropertiesToProject.contains("id")) newProperties.put("dep-id", newProperties.get("dep-id")+depProperties.get("id")+"|");
+						if (depsPropertiesToProject.contains("form")) newProperties.put("dep-form", newProperties.get("dep-form")+depProperties.get("form")+"|");
+						if (depsPropertiesToProject.contains("lemma")) newProperties.put("dep-lemma", newProperties.get("dep-lemma")+depProperties.get("lemma")+"|");
+						if (depsPropertiesToProject.contains("upos")) newProperties.put("dep-upos", newProperties.get("dep-upos")+depProperties.get("upos")+"|");
+						if (depsPropertiesToProject.contains("xpos")) newProperties.put("dep-xpos", newProperties.get("dep-xpos")+depProperties.get("xpos")+"|");
+						if (depsPropertiesToProject.contains("deprel")) newProperties.put("dep-deprel", newProperties.get("dep-deprel")+depProperties.get("deprel")+"|");
+						if (depsPropertiesToProject.contains("deps")) newProperties.put("dep-deps", newProperties.get("dep-deps")+depProperties.get("deps")+"|");
+						if (depsPropertiesToProject.contains("misc")) properties.put("dep-misc", newProperties.get("dep-misc")+depProperties.get("misc")+"|");
+					}
+				}
+				
+				for (String newProp : newProperties.keySet()) {
+					properties.put(newProp, newProperties.get(newProp));
+				}
+			}
+		}
+		//System.out.println("Result "+sentenceProperties);
+	}
+	
+	private static void storeSentenceProperties(LinkedHashMap<String, HashMap<String, String>> sentenceProperties, XMLTXMWordPropertiesInjection processor, String propertiesPrefix, Set<String> headPropertiesToProject, Set<String> depsPropertiesToProject) throws IOException, XMLStreamException {
+		
+		buildPropertiesProjections(sentenceProperties, headPropertiesToProject, depsPropertiesToProject);
+		
+		for (String id : sentenceProperties.keySet()) {
+			HashMap<String, String> properties = sentenceProperties.get(id);
+			ArrayList<String> propertyNames = new ArrayList<String>(properties.keySet());
+			
+			for (String p : propertyNames) {
+				
+				if (p.startsWith("#")) continue; //property already prefixed with #, do not add the prefix
+				
+				String value = properties.get(p);
+				properties.remove(p);
+				properties.put("#"+propertiesPrefix+p, value);
+			}
+			processor.addProperty(id, properties);
+		}
+		
+		sentenceProperties.clear();
+	}
+}

Index: TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/UDTreeSearchSelector.java
===================================================================
--- TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/UDTreeSearchSelector.java	(revision 0)
+++ TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/UDTreeSearchSelector.java	(revision 3300)
@@ -0,0 +1,37 @@
+package org.txm.conllu.core.function;
+
+import org.txm.searchengine.core.Query;
+import org.txm.searchengine.cqp.corpus.CQPCorpus;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+import org.txm.treesearch.function.TreeSearch;
+import org.txm.treesearch.function.TreeSearchSelector;
+
+
+public class UDTreeSearchSelector extends TreeSearchSelector {
+	
+	public static String UD = "UD";
+	
+	@Override
+	public String getEngine() {
+		
+		return UD;
+	}
+	
+	@Override
+	public boolean canComputeWith(CQPCorpus corpus) {
+		
+		return UDUSearch.hasUDProperties(corpus);
+	}
+	
+	@Override
+	public TreeSearch getTreeSearch(CQPCorpus corpus) {
+		
+		return new UDUSearch(corpus);
+	}
+
+	@Override
+	public Class<? extends Query> getQueryClass() {
+		
+		return CQLQuery.class;
+	}
+}

Index: TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/UDUSearch.java
===================================================================
--- TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/UDUSearch.java	(revision 0)
+++ TXM/trunk/org.txm.connlu.core/src/org/txm/conllu/core/function/UDUSearch.java	(revision 3300)
@@ -0,0 +1,328 @@
+package org.txm.conllu.core.function;
+
+import java.io.File;
+import java.util.ArrayList;
+import java.util.HashMap;
+import java.util.List;
+
+import org.apache.commons.lang.StringUtils;
+import org.txm.conllu.core.preferences.UDPreferences;
+import org.txm.core.results.TXMParameters;
+import org.txm.libs.deptreeviz.UDPrintTree;
+import org.txm.searchengine.cqp.CQPSearchEngine;
+import org.txm.searchengine.cqp.clientExceptions.CqiClientException;
+import org.txm.searchengine.cqp.corpus.CQPCorpus;
+import org.txm.searchengine.cqp.corpus.QueryResult;
+import org.txm.searchengine.cqp.corpus.StructuralUnitProperty;
+import org.txm.searchengine.cqp.corpus.WordProperty;
+import org.txm.searchengine.cqp.corpus.query.CQLQuery;
+import org.txm.searchengine.cqp.corpus.query.Match;
+import org.txm.treesearch.function.TreeSearch;
+import org.txm.treesearch.function.TreeSearchSelector;
+import org.txm.utils.TXMProgressMonitor;
+import org.txm.utils.logger.Log;
+
+public class UDUSearch extends TreeSearch {
+	
+	protected boolean ready = false;
+	
+	CQPCorpus udSentences;
+
+	private QueryResult matches;
+	
+	public UDUSearch(CQPCorpus corpus) {
+		this(null, corpus);
+	}
+	
+	public UDUSearch(String parentNodePath, CQPCorpus corpus) {
+		super(parentNodePath, corpus);
+		
+		this.corpus = getParent();
+		
+		ready = hasUDProperties(corpus, UDPreferences.getInstance().getProjectPreferenceValue(corpus.getProject(), UDPreferences.UDPREFIX, UDPreferences.getInstance().getString(UDPreferences.UDPREFIX)));
+	}
+	
+	public UDUSearch(String parentNodePath) {
+		this(parentNodePath, null);
+	}
+	
+	public boolean isComputed() {
+		return matches != null;
+	}
+	
+	public boolean isDrawn() {
+		return matches != null;
+	}
+	
+	public boolean toSVG(File svgFile, int sent, int sub, String T, String NT) {
+		if (!isDrawn()) return false; // no result
+		try {
+			//File file = File.createTempFile("txm", ".svg", new File(Toolbox.getTxmHomePath(), "results"));
+			
+			Match match = this.matches.getMatches().get(sent);
+			Match sentence = null;
+			for (Match s : udSentences.getMatches()) {
+				if (s.getStart() <= match.getStart() && match.getEnd() <= s.getEnd()) {
+					sentence = s;
+					break;
+				}
+			}
+			
+			if (sentence == null) {
+				Log.warning("Error: match positions not found in sentences positions");
+				return false;
+			}
+			
+			int[] positions = new int[sentence.size()];
+			for (int i = 0 ; i < sentence.size() ; i++) positions[i] = sentence.getStart()+i;
+			
+			String prefix = UDPreferences.getInstance().getProjectPreferenceValue(corpus.getProject(), UDPreferences.UDPREFIX, UDPreferences.getInstance().getString(UDPreferences.UDPREFIX));
+			
+			HashMap<String, String[]> values = new HashMap<>();
+			for (String p : ImportCoNLLUAnnotations.UD_PROPERTY_NAMES) {
+				values.put(prefix+p, corpus.getProperty(prefix+p).cpos2Str(positions));
+			}
+			
+			ArrayList<String> conll = new ArrayList<String>();
+			
+			for (int p = 0 ; p < positions.length ; p++) {
+				StringBuilder buffer = new StringBuilder();
+				for (String prop : ImportCoNLLUAnnotations.UD_PROPERTY_NAMES) {
+					if (buffer.length() > 0) buffer.append("\t");
+					buffer.append(values.get(prefix+prop)[p]);
+				}
+				
+				conll.add(buffer.toString());
+			}
+			Log.info("CoNLL-U:");
+			for (String l : conll) {
+				Log.info(l);
+			}
+			return UDPrintTree.print(svgFile, conll) != null;
+		}
+		catch (Throwable e) {
+			Log.warning("Error while drawing SVG: "+e+ " at "+e.getStackTrace()[0]);
+			Log.printStackTrace(e);
+			return false;
+		}
+	}
+	
+	public String[] getAvailableTProperties() {
+		
+		String prefix = UDPreferences.getInstance().getProjectPreferenceValue(corpus.getProject(), UDPreferences.UDPREFIX, UDPreferences.getInstance().getString(UDPreferences.UDPREFIX));
+		
+		String[] properties = new String[ImportCoNLLUAnnotations.UD_PROPERTY_NAMES.length];
+		for (int p = 0 ; p < ImportCoNLLUAnnotations.UD_PROPERTY_NAMES.length ; p++) {
+			properties[p] = prefix+ImportCoNLLUAnnotations.UD_PROPERTY_NAMES[p];
+		}
+		return properties;
+	}
+	
+	public String[] getAvailableNTProperties() {
+		return getAvailableTProperties();
+	}
+	
+	@Override
+	public CQPCorpus getParent() {
+		return (CQPCorpus) super.getParent();
+	}
+	
+	public boolean isReady() {
+		return ready;
+	}
+	
+	public String getT() {
+		return T;
+	}
+	
+	public String getNT() {
+		return NT;
+	}
+	
+	public int getNSentences() {
+		if (matches == null) return 0;
+		
+			try {
+				return matches.getMatches().size();
+			}
+			catch (CqiClientException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+				return 0;
+			}//getNMatch();
+	}
+	
+	public int getNSubGraph(int matchNo) {
+		
+		return 1;
+	}
+	
+	public int getSub(int matchNo) {
+		
+		return 1;
+	}
+	
+	/**
+	 * @return the query or the generic one
+	 */
+	public String getQuery() {
+		
+		String prefix = UDPreferences.getInstance().getProjectPreferenceValue(corpus.getProject(), UDPreferences.UDPREFIX, UDPreferences.getInstance().getString(UDPreferences.UDPREFIX));
+		
+		if (pQuery == null || pQuery.getQueryString().length() ==0) {
+			return "["+prefix+"id=\"1\"]";
+		} else {
+			return pQuery.getQueryString();
+		}
+	}
+	
+	@Override
+	public String toString() {
+		if (pQuery != null) {
+			return pQuery.getQueryString().substring(0, Math.min(20, pQuery.getQueryString().length()));
+		}
+		return "" + corpus;
+	}
+	
+	@Override
+	public boolean _toTxt(File outfile, String encoding, String colseparator, String txtseparator) throws Exception {
+		return false;
+	}
+	
+	@Override
+	public void clean() {
+		
+	}
+	
+	/**
+	 * 
+	 * @return the array of extensions to show in the FileDialog SWT widget
+	 */
+	@Override
+	public String[] getExportTXTExtensions() {
+		return new String[] { "*.xml" };
+	}
+	
+	@Override
+	public boolean canCompute() {
+		return corpus != null; // && pQuery != null && pQuery.length() > 0; // if pQuery is empty/null set a default query
+	}
+	
+	@Override
+	public boolean setParameters(TXMParameters parameters) {
+		if (parameters.getString("query") != null) {
+			this.pQuery = new CQLQuery(parameters.getString("query"));
+		}
+		return true;
+	}
+	
+	@Override
+	public boolean saveParameters() throws Exception {
+		return true;
+	}
+	
+	@Override
+	public boolean loadParameters() throws Exception {
+		return true;
+	}
+	
+	@Override
+	protected boolean _compute(TXMProgressMonitor monitor) throws Exception {
+		
+		String prefix = UDPreferences.getInstance().getProjectPreferenceValue(corpus.getProject(), UDPreferences.UDPREFIX, UDPreferences.getInstance().getString(UDPreferences.UDPREFIX));
+		
+		
+		if (pQuery == null || pQuery.getQueryString().length() == 0) {
+			pQuery = new CQLQuery("["+prefix+"id=\"1\"]");
+		}
+		
+		udSentences = corpus.getSubcorpusByName(corpus.getName()+"/ud-sentences");
+		if (udSentences != null) udSentences.compute();
+		
+		if (udSentences == null) {
+			udSentences = corpus.createSubcorpus(new CQLQuery("["+prefix+"id=\"1\"] ["+prefix+"id !=\"1\"]+ [:"+prefix+"id=\"1|__UNDEF__\":]"), "ud-sentences");
+			udSentences.setVisible(false);
+		}
+		
+		matches = udSentences.query((CQLQuery)pQuery, "matches", false);
+		
+		return matches.getNMatch() > 0;
+	}
+	
+	@Override
+	public String getResultType() {
+		return "UD search";
+	}
+	
+	public void setIndexAndSubIndex(int sent, int sub) {
+		this.index = sent;
+		this.subIndex = sub;
+	}
+	
+	@Override
+	public boolean hasSubMatchesStrategy() {
+		
+		return false;
+	}
+	
+	public static boolean hasUDProperties(CQPCorpus corpus) {
+		return hasUDProperties(corpus, UDPreferences.getInstance().getProjectPreferenceValue(corpus.getProject(), UDPreferences.UDPREFIX, UDPreferences.getInstance().getString(UDPreferences.UDPREFIX)));
+	}
+	
+	public static boolean hasUDProperties(CQPCorpus corpus, String prefix) {
+		
+		for (String prop : ImportCoNLLUAnnotations.UD_PROPERTY_NAMES) {
+			try {
+				if (corpus.getProperty(prefix+prop) == null) return false;
+			}
+			catch (CqiClientException e) {
+				return false;
+			}
+		}
+		return true;
+	}
+
+	@Override
+	public String getEngine() {
+		
+		return UDTreeSearchSelector.UD;
+	}
+
+	@Override
+	public TreeSearchSelector getSelector() {
+		
+		return new UDTreeSearchSelector();
+	}
+
+	@Override
+	public String[] getTextAndWordIDSOfCurrentSentence() throws Exception {
+		
+		String[] textAndWord = new String[2];
+		
+		WordProperty pid = corpus.getProperty("id");
+		StructuralUnitProperty ptextid = corpus.getStructuralUnitProperty("text_id");
+		
+		Match match = this.udSentences.getMatches().get(this.index);
+		int[] positions = new int[match.size()];
+		for (int i = 0 ; i < match.size() ; i++) {
+			positions[i] = match.getStart() + i;
+		}
+		
+		List<String> idvalues = CQPSearchEngine.getEngine().getValuesForProperty(positions, pid);
+		
+		int[] structid = CQPSearchEngine.getCqiClient().cpos2Struc(ptextid.getQualifiedName(), positions);
+		String[] values = CQPSearchEngine.getCqiClient().struc2Str(ptextid.getQualifiedName(), structid);
+		
+		textAndWord[0] = values[0];
+		textAndWord[1] = StringUtils.join(idvalues, ",");
+		
+		return textAndWord;
+	}
+
+	@Override
+	public String getIconPath() {
+		
+		return "platform:/plugin/org.txm.conllu.core/icons/functions/UD.png";
+	}
+
+}

Index: TXM/trunk/org.txm.imports.metopes/src/org/txm/imports/metopes/DoInstallStep.java
===================================================================
--- TXM/trunk/org.txm.imports.metopes/src/org/txm/imports/metopes/DoInstallStep.java	(revision 3299)
+++ TXM/trunk/org.txm.imports.metopes/src/org/txm/imports/metopes/DoInstallStep.java	(revision 3300)
@@ -43,21 +43,21 @@
 		
 		File macroDirectory = new File(Toolbox.getTxmHomePath(), "scripts/macro/org/txm/macro");
 		macroDirectory.mkdirs();
-		if (!BundleUtils.copyFiles("org.txm.imports.metopes", "src", "org/txm/macro/", "metopes", macroDirectory)) {
+		if (!BundleUtils.copyFiles("org.txm.imports.metopes", "src", "org/txm/macro/", "metopes", macroDirectory, true)) {
 			Log.severe("Error while coping Metopes org/txm/macro/metopes in "+macroDirectory.getAbsolutePath());
 			return;
 		}
 		
 		File importDirectory = new File(Toolbox.getTxmHomePath(), "scripts/import");
 		importDirectory.mkdirs();
-		if (!BundleUtils.copyFiles("org.txm.imports.metopes", "src", "org/txm/importer/metopes", "metopesLoader.groovy", importDirectory)) {
+		if (!BundleUtils.copyFiles("org.txm.imports.metopes", "src", "org/txm/importer/metopes", "metopesLoader.groovy", importDirectory, true)) {
 			Log.severe("Error while coping Metopes org/txm/importer/metopes in "+importDirectory.getAbsolutePath());
 			return;
 		}
 		
 		File xslDirectory = new File(Toolbox.getTxmHomePath(), "xsl");
 		xslDirectory.mkdirs();
-		if (!BundleUtils.copyFiles("org.txm.imports.metopes", "res", "org/txm/xml/xsl", "metopes", xslDirectory)) {
+		if (!BundleUtils.copyFiles("org.txm.imports.metopes", "res", "org/txm/xml/xsl", "metopes", xslDirectory, true)) {
 			Log.severe("Error while coping Metopes org/txm/xml/xsl/metopes in "+xslDirectory.getAbsolutePath());
 			return;
 		}
Index: TXM/trunk/org.txm.core/src/java/org/txm/utils/BundleUtils.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/utils/BundleUtils.java	(revision 3299)
+++ TXM/trunk/org.txm.core/src/java/org/txm/utils/BundleUtils.java	(revision 3300)
@@ -146,6 +146,10 @@
 	// return bundleDir;
 	// }
 	
+	public static boolean copyFiles(String bundle_id, String source_relative_directory, String file_path, String file_name, File outputDirectory) {
+		return copyFiles(bundle_id, source_relative_directory, file_path, file_name, outputDirectory, true);
+	}
+	
 	/**
 	 * Copy a file from the bundle directory or Jar to @outputDirectory
 	 * 
@@ -158,7 +162,7 @@
 	 * @param outputDirectory
 	 * @return true if success
 	 */
-	public static boolean copyFiles(String bundle_id, String source_relative_directory, String file_path, String file_name, File outputDirectory) {
+	public static boolean copyFiles(String bundle_id, String source_relative_directory, String file_path, String file_name, File outputDirectory, boolean replace) {
 		
 		if (source_relative_directory.length() > 0 && !source_relative_directory.endsWith("/")) source_relative_directory += "/";
 		if (file_path.length() > 0 && !file_path.endsWith("/")) file_path += "/";
@@ -173,9 +177,10 @@
 			}
 			try {
 				if (fileInToolbox.isDirectory())
-					FileCopy.copyFiles(fileInToolbox, outfile);
-				else
-					FileCopy.copy(fileInToolbox, outfile);
+					FileCopy.copyFiles(fileInToolbox, outfile, replace);
+				else {
+					FileCopy.copy(fileInToolbox, outfile, replace);
+				}
 			}
 			catch (IOException e) {
 				System.out.println("Copy of ressource script failed: " + e);
Index: TXM/trunk/org.txm.core/src/java/org/txm/core/engines/EnginesManager.java
===================================================================
--- TXM/trunk/org.txm.core/src/java/org/txm/core/engines/EnginesManager.java	(revision 3299)
+++ TXM/trunk/org.txm.core/src/java/org/txm/core/engines/EnginesManager.java	(revision 3300)
@@ -2,7 +2,9 @@
 
 import java.util.HashMap;
 
+import org.eclipse.core.internal.registry.ConfigurationElementHandle;
 import org.eclipse.core.runtime.IConfigurationElement;
+import org.eclipse.core.runtime.IContributor;
 import org.eclipse.core.runtime.IProgressMonitor;
 import org.eclipse.core.runtime.RegistryFactory;
 import org.txm.core.messages.TXMCoreMessages;
